 /* 
 ********************************************************************* 
 **  Released from   : C-IRC Modules
 **  Description     : Crypthon authentication system
 **  Written by      : srcmaster <srcmaster@crypthon.org>
 **  Web page        : htttp://www.crypthon.org
 *********************************************************************
 */

static char lastedited[] = "@(#) m_auth.c  1.1 (srcmaster) 2006/02/20 16:36:39 ~ 2014/04/21 15:21:45";

#include "config.h"
#include "struct.h"
#include "common.h"
#include "sys.h"
#include "numeric.h"
#include "msg.h"
#include "proto.h"
#include "channel.h"
#include <time.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef _WIN32
#include <io.h>
#endif
#include <fcntl.h>
#include "h.h"
#ifdef STRIPBADWORDS
#include "badwords.h"
#endif
#ifdef _WIN32
#include "version.h"
#endif

#include <mysql/mysql.h>
#include <mysql/errmsg.h>

#ifndef UNREAL_VERSION_TIME
 #define UNREAL_VERSION_TIME 0
#endif

#ifdef MAXUSERS
#undef MAXUSERS
#endif
#if MAXCONNECTIONS < 4096
#define MAXUSERS	4096
#else
#define MAXUSERS	MAXCONNETIONS
#endif

#define SQL_BAGLANTI_SURESI 5
#define AUTH_KOD_UZUNLUGU 5
#define YASAK_KARAKTERLER "lI0jJABCDEFGHIJKLMNOPQRSTUVWXYZ"
#define AUTH_KANALLARI "#sohbet"

#define host "localhost"
#define kullanici "auth_user"
#define kullanicisifresi "auth_pass"
#define veritabani "auth_db"
#define sqlportu 3306

#define Client(x) auser[x->slot]
typedef struct _clientvalues ClientValues;
struct _clientvalues {
	char id[32]; 
	int authorized; 
	int girisim_sayisi; 
	char kod[16]; 
};

static ClientValues *auser[MAXUSERS];

MYSQL *db = NULL;

static Hook *UserConnect = NULL;
static Hook *LUserQuit = NULL;
static Hook *RUserQuit = NULL;
static Hook *CheckJoin = NULL;

DLLFUNC int m_authorize(aClient *cptr, aClient *sptr, int parc, char *parv[]);
DLLFUNC char *ozel_mesaj_kontrolu(aClient *, aClient *, aClient *, char *, int);
DLLFUNC int kullanici_girisi(aClient *);
DLLFUNC int kullanici_cikisi(aClient *, char *);
static int kanal_girisi(aClient *, aChannel *, char *[]);

static int sql_baglanti_ac();
static void sql_baglanti_kapat();
static void sql_tekrar_baglan();
static void sql_veri_sil(aClient *sptr);

#define MSG_AUTHORIZE		"AUTH"
#define TOK_AUTHORIZE		"UZ"

#define DESCRIPTION		"Client authentication system (written by srcmaster)"

ModuleHeader MOD_HEADER(authorize)
  = {
	"Authorize",
	"$Id: m_auth.c,v 1.1 2006/02/12 23:09:10 srcmaster Exp $",
	DESCRIPTION,
	"3.2-b8-1",
	NULL 
    };

#ifndef EXTCMODE
	#error "Ltfen include/config.h dizi altnda bulunan gelitirilmi kanal modlar(extended channel modes) seeneini aktif edin"
#endif

ModuleInfo AuthorizeModinfo;


DLLFUNC int MOD_INIT(m_authorize)(ModuleInfo *module)
{
	bcopy(module,&AuthorizeModinfo,module->size);
	ModuleSetOptions(AuthorizeModinfo.handle, MOD_OPT_PERM);
	UserConnect = HookAddEx(AuthorizeModinfo.handle, HOOKTYPE_LOCAL_CONNECT, kullanici_girisi);
	LUserQuit = HookAddEx(AuthorizeModinfo.handle, HOOKTYPE_LOCAL_QUIT, kullanici_cikisi);
	HookAddEx(AuthorizeModinfo.handle, HOOKTYPE_PRE_LOCAL_JOIN, kanal_girisi);
	CommandAdd(AuthorizeModinfo.handle, MSG_AUTHORIZE, TOK_AUTHORIZE, m_authorize, MAXPARA, M_USER);
	if (!(UserConnect || LUserQuit || RUserQuit))
		return MOD_FAILED;
	return MOD_SUCCESS;
}

DLLFUNC int MOD_LOAD(m_authorize)(int module_load)
{
	sql_baglanti_ac();
	EventAddEx(AuthorizeModinfo.handle, "sql_takrar_baglan", 15, 0, sql_tekrar_baglan, NULL);
	return MOD_SUCCESS;
}

DLLFUNC int MOD_UNLOAD(m_authorize)(int module_unload)
{
	HookDel(UserConnect);
	HookDel(LUserQuit);
	return MOD_SUCCESS;
}
static int sql_baglanti_ac()
{
	sql_baglanti_kapat();
	db = mysql_init(NULL);
	if (!db)
	{
		return 0;
	}

	if (SQL_BAGLANTI_SURESI)
	{
		unsigned int z = SQL_BAGLANTI_SURESI;
		mysql_options(db, MYSQL_OPT_CONNECT_TIMEOUT, (char *)&z);
	}

	if (!mysql_real_connect(db, host, kullanici, kullanicisifresi, veritabani, sqlportu, NULL, 0))
	{
		return 0;
	}

	if (mysql_query(db, "DELETE FROM srcauth"))
	{
		sql_baglanti_kapat();
		return 0;
	}

	db->reconnect = 1;
	sendto_realops("MySQL tanmland..");

	return 1;
}
static void sql_baglanti_kapat()
{
	if (db)
	{
		mysql_close(db);
		db = NULL;
	}
}
static void sql_tekrar_baglan()
{
	if (!db)
	{
		sql_baglanti_ac();
		return;
	}
	mysql_ping(db);
}

char *KodYarat(void)
{
static char kod[16];
int u,s;

	for (u = 0; u < AUTH_KOD_UZUNLUGU; u++)
	{
tekrar:
		s = getrandom8() % 62;
		if (s < 26)
			kod[u] = 'a' + s;
		else if (s < 52)
			kod[u] = 'A' + (s - 26);
		else
			kod[u] = '0' + (s - 52);

		if (strchr(YASAK_KARAKTERLER, kod[u]))
			goto tekrar;
	}

	kod[u] = '\0';
	
	return kod;
}
char *IdYarat(void)
{
static char kod[32];
int u,s;

	for (u = 0; u < 8; u++)
	{
tekrar:
		s = getrandom8() % 62;
		if (s < 26)
			kod[u] = 'a' + s;
		else if (s < 52)
			kod[u] = 'A' + (s - 26);
		else
			kod[u] = '0' + (s - 52);

		if (strchr(YASAK_KARAKTERLER, kod[u]))
			goto tekrar;
	}

	kod[u] = '\0';
	
	return kod;
}

int yetki_ver(aClient *sptr)
{
char *kanalarg[3], kanallar[512];

	Client(sptr)->authorized = 0;

	sql_veri_sil(sptr);
	
	strlcpy(kanallar, AUTH_KANALLARI, sizeof(kanallar));
	kanalarg[0] = sptr->name;
	kanalarg[1] = kanallar;
	kanalarg[2] = NULL;
	return do_cmd(sptr, sptr, "JOIN", 2, kanalarg);
}
static void sql_veri_sil(aClient *sptr)
{
char sorgu[256];
	
	ircsprintf(sorgu, "DELETE FROM srcauth WHERE id=%s;", Client(sptr)->id);
	if (db)
		mysql_query(db, sorgu);
}
DLLFUNC int kullanici_cikisi(aClient *sptr, char *comment)
{
	if (sptr->slot < 0)
	{
		return 0;
	}
	if (Client(sptr))
	{
		sql_veri_sil(sptr);
		memset(Client(sptr), 0, sizeof(ClientValues));
		MyFree(Client(sptr));
		Client(sptr) = NULL;
	}
	return 0;
}

DLLFUNC int kullanici_girisi(aClient *sptr)
{
char sorgu[2048];
char *hostmask;

	Client(sptr) = MyMallocEx(sizeof(ClientValues));

	strcpy(Client(sptr)->kod, KodYarat());
	strcpy(Client(sptr)->id, IdYarat());
	Client(sptr)->authorized = 1;	

	if (!db)
	{
		Client(sptr)->authorized = 0;
		return 0;
	}

	ircsprintf(sorgu, "INSERT INTO srcauth (id, kod) VALUES ('%s', '%s');", Client(sptr)->id, Client(sptr)->kod);
	if (mysql_query(db, sorgu))
	{
		Client(sptr)->authorized = 0;
		return 0;
	}
	
	sendto_one(sptr, ":%s NOTICE %s :Ltfen sunucumuzda sorunsuzca sohbet edebilmek iin yetkilendirme kodunuzu /auth <kod> eklinde giriniz..", me.name, sptr->name);
	sendto_one(sptr, ":%s NOTICE %s :Yetkilendirme kodunuz iin tklaynz: http://irc.xxxnet.org/int/auth.php?id=%s ", me.name, sptr->name, Client(sptr)->id);
	return 0;
}
DLLFUNC int m_authorize(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	if ((parc < 2) || BadPtr(parv[1]))
	{
		sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS), me.name, sptr->name, "AUTH");
		return 0;
	}
	
	if (!strcmp(parv[1], "getauth") && !BadPtr(parv[2]))
	{
		aClient *acptr;
		if (!IsAnOper(sptr))
		{
			sendto_one(cptr, err_str(ERR_NOPRIVILEGES), me.name, sptr->name);
			return 0;
		}
		acptr = find_person(parv[2], NULL);
		if (!acptr)
		{
			sendto_one(sptr, err_str(ERR_NOSUCHNICK), me.name, sptr->name, parv[2]);
			return 0;
		}
		sendnotice(sptr, "%s kullancsnn yetkilendirme kodu: %s ",
			acptr->name,
			Client(acptr)->kod);
		return 0;
	}

	if (!Client(sptr)->authorized)
		return 0;

	if (!strcmp(parv[1], Client(sptr)->kod))
	{
		sendnotice(sptr, "Ho sohbetler..");
		return yetki_ver(sptr);
	} else {
		sendnotice(sptr, "Kodunuz yanl..");
		if (++(Client(sptr)->authorized) > 3)
			return exit_client(sptr, sptr, sptr, "Fazla giriim yaptnz.");
	}
	return 0;
}


static int kanal_girisi(aClient *sptr, aChannel *chptr, char *parv[])
{
	if (Client(sptr)->authorized && !IsAnOper(sptr) && !IsULine(sptr) && !IsServer(sptr))
	{
		sendto_one(sptr, ":%s NOTICE %s :Yetkilendirme kodunuz iin tklaynz: http://irc.xxxnet.org/int/auth.php?id=%s ", me.name, sptr->name, Client(sptr)->id);
		return HOOK_DENY;
	}
	
	return HOOK_CONTINUE;
}
